/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava3.codegen.rxjava3;

import io.vertx.rxjava3.RxHelper;
import io.vertx.rxjava3.ObservableHelper;
import io.vertx.rxjava3.FlowableHelper;
import io.vertx.rxjava3.impl.AsyncResultMaybe;
import io.vertx.rxjava3.impl.AsyncResultSingle;
import io.vertx.rxjava3.impl.AsyncResultCompletable;
import io.vertx.rxjava3.WriteStreamObserver;
import io.vertx.rxjava3.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.rxjava3.MethodWithMultiCallback original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.rxjava3.MethodWithMultiCallback.class)
public class MethodWithMultiCallback {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    MethodWithMultiCallback that = (MethodWithMultiCallback) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<MethodWithMultiCallback> __TYPE_ARG = new TypeArg<>(    obj -> new MethodWithMultiCallback((io.vertx.codegen.rxjava3.MethodWithMultiCallback) obj),
    MethodWithMultiCallback::getDelegate
  );

  private final io.vertx.codegen.rxjava3.MethodWithMultiCallback delegate;
  
  public MethodWithMultiCallback(io.vertx.codegen.rxjava3.MethodWithMultiCallback delegate) {
    this.delegate = delegate;
  }

  public MethodWithMultiCallback(Object delegate) {
    this.delegate = (io.vertx.codegen.rxjava3.MethodWithMultiCallback)delegate;
  }

  public io.vertx.codegen.rxjava3.MethodWithMultiCallback getDelegate() {
    return delegate;
  }

  public io.reactivex.rxjava3.core.Completable multiCompletable() { 
    io.reactivex.rxjava3.core.Completable ret = rxMultiCompletable();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.CompletableHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Completable rxMultiCompletable() { 
    return AsyncResultCompletable.toCompletable( handler -> {
      delegate.multiCompletable(handler);
    });
  }

  public io.reactivex.rxjava3.core.Maybe<java.lang.String> multiMaybe() { 
    io.reactivex.rxjava3.core.Maybe<java.lang.String> ret = rxMultiMaybe();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.MaybeHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Maybe<java.lang.String> rxMultiMaybe() { 
    return AsyncResultMaybe.toMaybe( handler -> {
      delegate.multiMaybe(handler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.lang.String> multiSingle() { 
    io.reactivex.rxjava3.core.Single<java.lang.String> ret = rxMultiSingle();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.lang.String> rxMultiSingle() { 
    return AsyncResultSingle.toSingle( handler -> {
      delegate.multiSingle(handler);
    });
  }

  public static MethodWithMultiCallback newInstance(io.vertx.codegen.rxjava3.MethodWithMultiCallback arg) {
    return arg != null ? new MethodWithMultiCallback(arg) : null;
  }

}
