/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava3.codegen.rxjava3;

import io.vertx.rxjava3.RxHelper;
import io.vertx.rxjava3.ObservableHelper;
import io.vertx.rxjava3.FlowableHelper;
import io.vertx.rxjava3.impl.AsyncResultMaybe;
import io.vertx.rxjava3.impl.AsyncResultSingle;
import io.vertx.rxjava3.impl.AsyncResultCompletable;
import io.vertx.rxjava3.WriteStreamObserver;
import io.vertx.rxjava3.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 * Special case : we need to generate <code>Maybe<Void></code> because of covariant return type and because
 * <code>Completable</code> does not extend <code>Maybe</code>.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg.class)
public class MethodWithNullableTypeVariableParamByVoidArg extends io.vertx.rxjava3.codegen.rxjava3.MethodWithNullableTypeVariable<java.lang.Void> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    MethodWithNullableTypeVariableParamByVoidArg that = (MethodWithNullableTypeVariableParamByVoidArg) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<MethodWithNullableTypeVariableParamByVoidArg> __TYPE_ARG = new TypeArg<>(    obj -> new MethodWithNullableTypeVariableParamByVoidArg((io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg) obj),
    MethodWithNullableTypeVariableParamByVoidArg::getDelegate
  );

  private final io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg delegate;
  
  public MethodWithNullableTypeVariableParamByVoidArg(io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg delegate) {
    super(delegate);
    this.delegate = delegate;
  }

  public MethodWithNullableTypeVariableParamByVoidArg(Object delegate) {
    super((io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg)delegate);
    this.delegate = (io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg)delegate;
  }

  public io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg getDelegate() {
    return delegate;
  }

  public io.reactivex.rxjava3.core.Maybe<java.lang.Void> doSomethingWithMaybeResult() { 
    io.reactivex.rxjava3.core.Maybe<java.lang.Void> ret = rxDoSomethingWithMaybeResult();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.MaybeHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Maybe<java.lang.Void> rxDoSomethingWithMaybeResult() { 
    return AsyncResultMaybe.toMaybe( handler -> {
      delegate.doSomethingWithMaybeResult(handler);
    });
  }

  public static MethodWithNullableTypeVariableParamByVoidArg newInstance(io.vertx.codegen.rxjava3.MethodWithNullableTypeVariableParamByVoidArg arg) {
    return arg != null ? new MethodWithNullableTypeVariableParamByVoidArg(arg) : null;
  }

}
