/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava3.codegen.testmodel;

import io.vertx.rxjava3.RxHelper;
import io.vertx.rxjava3.ObservableHelper;
import io.vertx.rxjava3.FlowableHelper;
import io.vertx.rxjava3.impl.AsyncResultMaybe;
import io.vertx.rxjava3.impl.AsyncResultSingle;
import io.vertx.rxjava3.impl.AsyncResultCompletable;
import io.vertx.rxjava3.WriteStreamObserver;
import io.vertx.rxjava3.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;


@RxGen(io.vertx.codegen.testmodel.JsonMapperTCK.class)
public class JsonMapperTCK {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    JsonMapperTCK that = (JsonMapperTCK) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<JsonMapperTCK> __TYPE_ARG = new TypeArg<>(    obj -> new JsonMapperTCK((io.vertx.codegen.testmodel.JsonMapperTCK) obj),
    JsonMapperTCK::getDelegate
  );

  private final io.vertx.codegen.testmodel.JsonMapperTCK delegate;
  
  public JsonMapperTCK(io.vertx.codegen.testmodel.JsonMapperTCK delegate) {
    this.delegate = delegate;
  }

  public JsonMapperTCK(Object delegate) {
    this.delegate = (io.vertx.codegen.testmodel.JsonMapperTCK)delegate;
  }

  public io.vertx.codegen.testmodel.JsonMapperTCK getDelegate() {
    return delegate;
  }


  public void methodWithTypeToIntegerParam(io.vertx.codegen.testmodel.MyPojoToInteger myPojoToInteger) { 
    delegate.methodWithTypeToIntegerParam(myPojoToInteger);
  }

  public void methodWithListOfTypeToIntegerParam(java.util.List<io.vertx.codegen.testmodel.MyPojoToInteger> myPojoToIntegerList) { 
    delegate.methodWithListOfTypeToIntegerParam(myPojoToIntegerList);
  }

  public void methodWithSetOfTypeToIntegerParam(java.util.Set<io.vertx.codegen.testmodel.MyPojoToInteger> myPojoToIntegerSet) { 
    delegate.methodWithSetOfTypeToIntegerParam(myPojoToIntegerSet);
  }

  public void methodWithMapOfTypeToIntegerParam(java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToInteger> myPojoToIntegerMap) { 
    delegate.methodWithMapOfTypeToIntegerParam(myPojoToIntegerMap);
  }

  public io.vertx.codegen.testmodel.MyPojoToInteger methodWithTypeToIntegerReturn() { 
    io.vertx.codegen.testmodel.MyPojoToInteger ret = delegate.methodWithTypeToIntegerReturn();
    return ret;
  }

  public java.util.List<io.vertx.codegen.testmodel.MyPojoToInteger> methodWithListOfTypeToIntegerReturn() { 
    java.util.List<io.vertx.codegen.testmodel.MyPojoToInteger> ret = delegate.methodWithListOfTypeToIntegerReturn();
    return ret;
  }

  public java.util.Set<io.vertx.codegen.testmodel.MyPojoToInteger> methodWithSetOfTypeToIntegerReturn() { 
    java.util.Set<io.vertx.codegen.testmodel.MyPojoToInteger> ret = delegate.methodWithSetOfTypeToIntegerReturn();
    return ret;
  }

  public java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToInteger> methodWithMapOfTypeToIntegerReturn() { 
    java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToInteger> ret = delegate.methodWithMapOfTypeToIntegerReturn();
    return ret;
  }

  public void methodWithHandlerTypeToIntegerParam(io.vertx.core.Handler<io.vertx.codegen.testmodel.MyPojoToInteger> myPojoToIntegerHandler) { 
    delegate.methodWithHandlerTypeToIntegerParam(myPojoToIntegerHandler);
  }

  public void methodWithHandlerListOfTypeToIntegerParam(io.vertx.core.Handler<java.util.List<io.vertx.codegen.testmodel.MyPojoToInteger>> myPojoToIntegerListHandler) { 
    delegate.methodWithHandlerListOfTypeToIntegerParam(myPojoToIntegerListHandler);
  }

  public void methodWithHandlerSetOfTypeToIntegerParam(io.vertx.core.Handler<java.util.Set<io.vertx.codegen.testmodel.MyPojoToInteger>> myPojoToIntegerSetHandler) { 
    delegate.methodWithHandlerSetOfTypeToIntegerParam(myPojoToIntegerSetHandler);
  }

  public void methodWithHandlerMapOfTypeToIntegerParam(io.vertx.core.Handler<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToInteger>> myPojoToIntegerMapHandler) { 
    delegate.methodWithHandlerMapOfTypeToIntegerParam(myPojoToIntegerMapHandler);
  }

  public io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToInteger> methodWithHandlerAsyncResultTypeToIntegerParam() { 
    io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToInteger> ret = rxMethodWithHandlerAsyncResultTypeToIntegerParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToInteger> rxMethodWithHandlerAsyncResultTypeToIntegerParam() { 
    return AsyncResultSingle.toSingle( myPojoToIntegerHandler -> {
      delegate.methodWithHandlerAsyncResultTypeToIntegerParam(myPojoToIntegerHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToInteger>> methodWithHandlerAsyncResultListOfTypeToIntegerParam() { 
    io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToInteger>> ret = rxMethodWithHandlerAsyncResultListOfTypeToIntegerParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToInteger>> rxMethodWithHandlerAsyncResultListOfTypeToIntegerParam() { 
    return AsyncResultSingle.toSingle( myPojoToIntegerListHandler -> {
      delegate.methodWithHandlerAsyncResultListOfTypeToIntegerParam(myPojoToIntegerListHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToInteger>> methodWithHandlerAsyncResultSetOfTypeToIntegerParam() { 
    io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToInteger>> ret = rxMethodWithHandlerAsyncResultSetOfTypeToIntegerParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToInteger>> rxMethodWithHandlerAsyncResultSetOfTypeToIntegerParam() { 
    return AsyncResultSingle.toSingle( myPojoToIntegerSetHandler -> {
      delegate.methodWithHandlerAsyncResultSetOfTypeToIntegerParam(myPojoToIntegerSetHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToInteger>> methodWithHandlerAsyncResultMapOfTypeToIntegerParam() { 
    io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToInteger>> ret = rxMethodWithHandlerAsyncResultMapOfTypeToIntegerParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToInteger>> rxMethodWithHandlerAsyncResultMapOfTypeToIntegerParam() { 
    return AsyncResultSingle.toSingle( myPojoToIntegerMapHandler -> {
      delegate.methodWithHandlerAsyncResultMapOfTypeToIntegerParam(myPojoToIntegerMapHandler);
    });
  }

  public void methodWithTypeToStringParam(java.time.ZonedDateTime zonedDateTime) { 
    delegate.methodWithTypeToStringParam(zonedDateTime);
  }

  public void methodWithListOfTypeToStringParam(java.util.List<java.time.ZonedDateTime> zonedDateTimeList) { 
    delegate.methodWithListOfTypeToStringParam(zonedDateTimeList);
  }

  public void methodWithSetOfTypeToStringParam(java.util.Set<java.time.ZonedDateTime> zonedDateTimeSet) { 
    delegate.methodWithSetOfTypeToStringParam(zonedDateTimeSet);
  }

  public void methodWithMapOfTypeToStringParam(java.util.Map<java.lang.String,java.time.ZonedDateTime> zonedDateTimeMap) { 
    delegate.methodWithMapOfTypeToStringParam(zonedDateTimeMap);
  }

  public java.time.ZonedDateTime methodWithTypeToStringReturn() { 
    java.time.ZonedDateTime ret = delegate.methodWithTypeToStringReturn();
    return ret;
  }

  public java.util.List<java.time.ZonedDateTime> methodWithListOfTypeToStringReturn() { 
    java.util.List<java.time.ZonedDateTime> ret = delegate.methodWithListOfTypeToStringReturn();
    return ret;
  }

  public java.util.Set<java.time.ZonedDateTime> methodWithSetOfTypeToStringReturn() { 
    java.util.Set<java.time.ZonedDateTime> ret = delegate.methodWithSetOfTypeToStringReturn();
    return ret;
  }

  public java.util.Map<java.lang.String,java.time.ZonedDateTime> methodWithMapOfTypeToStringReturn() { 
    java.util.Map<java.lang.String,java.time.ZonedDateTime> ret = delegate.methodWithMapOfTypeToStringReturn();
    return ret;
  }

  public void methodWithHandlerTypeToStringParam(io.vertx.core.Handler<java.time.ZonedDateTime> zonedDateTimeHandler) { 
    delegate.methodWithHandlerTypeToStringParam(zonedDateTimeHandler);
  }

  public void methodWithHandlerListOfTypeToStringParam(io.vertx.core.Handler<java.util.List<java.time.ZonedDateTime>> zonedDateTimeListHandler) { 
    delegate.methodWithHandlerListOfTypeToStringParam(zonedDateTimeListHandler);
  }

  public void methodWithHandlerSetOfTypeToStringParam(io.vertx.core.Handler<java.util.Set<java.time.ZonedDateTime>> zonedDateTimeSetHandler) { 
    delegate.methodWithHandlerSetOfTypeToStringParam(zonedDateTimeSetHandler);
  }

  public void methodWithHandlerMapOfTypeToStringParam(io.vertx.core.Handler<java.util.Map<java.lang.String,java.time.ZonedDateTime>> zonedDateTimeMapHandler) { 
    delegate.methodWithHandlerMapOfTypeToStringParam(zonedDateTimeMapHandler);
  }

  public io.reactivex.rxjava3.core.Single<java.time.ZonedDateTime> methodWithHandlerAsyncResultTypeToStringParam() { 
    io.reactivex.rxjava3.core.Single<java.time.ZonedDateTime> ret = rxMethodWithHandlerAsyncResultTypeToStringParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.time.ZonedDateTime> rxMethodWithHandlerAsyncResultTypeToStringParam() { 
    return AsyncResultSingle.toSingle( zonedDateTimeHandler -> {
      delegate.methodWithHandlerAsyncResultTypeToStringParam(zonedDateTimeHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.List<java.time.ZonedDateTime>> methodWithHandlerAsyncResultListOfTypeToStringParam() { 
    io.reactivex.rxjava3.core.Single<java.util.List<java.time.ZonedDateTime>> ret = rxMethodWithHandlerAsyncResultListOfTypeToStringParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.List<java.time.ZonedDateTime>> rxMethodWithHandlerAsyncResultListOfTypeToStringParam() { 
    return AsyncResultSingle.toSingle( zonedDateTimeListHandler -> {
      delegate.methodWithHandlerAsyncResultListOfTypeToStringParam(zonedDateTimeListHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.Set<java.time.ZonedDateTime>> methodWithHandlerAsyncResultSetOfTypeToStringParam() { 
    io.reactivex.rxjava3.core.Single<java.util.Set<java.time.ZonedDateTime>> ret = rxMethodWithHandlerAsyncResultSetOfTypeToStringParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.Set<java.time.ZonedDateTime>> rxMethodWithHandlerAsyncResultSetOfTypeToStringParam() { 
    return AsyncResultSingle.toSingle( zonedDateTimeSetHandler -> {
      delegate.methodWithHandlerAsyncResultSetOfTypeToStringParam(zonedDateTimeSetHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,java.time.ZonedDateTime>> methodWithHandlerAsyncResultMapOfTypeToStringParam() { 
    io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,java.time.ZonedDateTime>> ret = rxMethodWithHandlerAsyncResultMapOfTypeToStringParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,java.time.ZonedDateTime>> rxMethodWithHandlerAsyncResultMapOfTypeToStringParam() { 
    return AsyncResultSingle.toSingle( zonedDateTimeMapHandler -> {
      delegate.methodWithHandlerAsyncResultMapOfTypeToStringParam(zonedDateTimeMapHandler);
    });
  }

  public void methodWithTypeToJsonArrayParam(io.vertx.codegen.testmodel.MyPojoToJsonArray myPojoToJsonArray) { 
    delegate.methodWithTypeToJsonArrayParam(myPojoToJsonArray);
  }

  public void methodWithListOfTypeToJsonArrayParam(java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonArray> myPojoToJsonArrayList) { 
    delegate.methodWithListOfTypeToJsonArrayParam(myPojoToJsonArrayList);
  }

  public void methodWithSetOfTypeToJsonArrayParam(java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonArray> myPojoToJsonArraySet) { 
    delegate.methodWithSetOfTypeToJsonArrayParam(myPojoToJsonArraySet);
  }

  public void methodWithMapOfTypeToJsonArrayParam(java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonArray> myPojoToJsonArrayMap) { 
    delegate.methodWithMapOfTypeToJsonArrayParam(myPojoToJsonArrayMap);
  }

  public io.vertx.codegen.testmodel.MyPojoToJsonArray methodWithTypeToJsonArrayReturn() { 
    io.vertx.codegen.testmodel.MyPojoToJsonArray ret = delegate.methodWithTypeToJsonArrayReturn();
    return ret;
  }

  public java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonArray> methodWithListOfTypeToJsonArrayReturn() { 
    java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonArray> ret = delegate.methodWithListOfTypeToJsonArrayReturn();
    return ret;
  }

  public java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonArray> methodWithSetOfTypeToJsonArrayReturn() { 
    java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonArray> ret = delegate.methodWithSetOfTypeToJsonArrayReturn();
    return ret;
  }

  public java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonArray> methodWithMapOfTypeToJsonArrayReturn() { 
    java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonArray> ret = delegate.methodWithMapOfTypeToJsonArrayReturn();
    return ret;
  }

  public void methodWithHandlerTypeToJsonArrayParam(io.vertx.core.Handler<io.vertx.codegen.testmodel.MyPojoToJsonArray> myPojoToJsonArrayHandler) { 
    delegate.methodWithHandlerTypeToJsonArrayParam(myPojoToJsonArrayHandler);
  }

  public void methodWithHandlerListOfTypeToJsonArrayParam(io.vertx.core.Handler<java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonArray>> myPojoToJsonArrayListHandler) { 
    delegate.methodWithHandlerListOfTypeToJsonArrayParam(myPojoToJsonArrayListHandler);
  }

  public void methodWithHandlerSetOfTypeToJsonArrayParam(io.vertx.core.Handler<java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonArray>> myPojoToJsonArraySetHandler) { 
    delegate.methodWithHandlerSetOfTypeToJsonArrayParam(myPojoToJsonArraySetHandler);
  }

  public void methodWithHandlerMapOfTypeToJsonArrayParam(io.vertx.core.Handler<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonArray>> myPojoToJsonArrayMapHandler) { 
    delegate.methodWithHandlerMapOfTypeToJsonArrayParam(myPojoToJsonArrayMapHandler);
  }

  public io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToJsonArray> methodWithHandlerAsyncResultTypeToJsonArrayParam() { 
    io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToJsonArray> ret = rxMethodWithHandlerAsyncResultTypeToJsonArrayParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToJsonArray> rxMethodWithHandlerAsyncResultTypeToJsonArrayParam() { 
    return AsyncResultSingle.toSingle( myPojoToJsonArrayHandler -> {
      delegate.methodWithHandlerAsyncResultTypeToJsonArrayParam(myPojoToJsonArrayHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonArray>> methodWithHandlerAsyncResultListOfTypeToJsonArrayParam() { 
    io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonArray>> ret = rxMethodWithHandlerAsyncResultListOfTypeToJsonArrayParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonArray>> rxMethodWithHandlerAsyncResultListOfTypeToJsonArrayParam() { 
    return AsyncResultSingle.toSingle( myPojoToJsonArrayListHandler -> {
      delegate.methodWithHandlerAsyncResultListOfTypeToJsonArrayParam(myPojoToJsonArrayListHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonArray>> methodWithHandlerAsyncResultSetOfTypeToJsonArrayParam() { 
    io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonArray>> ret = rxMethodWithHandlerAsyncResultSetOfTypeToJsonArrayParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonArray>> rxMethodWithHandlerAsyncResultSetOfTypeToJsonArrayParam() { 
    return AsyncResultSingle.toSingle( myPojoToJsonArraySetHandler -> {
      delegate.methodWithHandlerAsyncResultSetOfTypeToJsonArrayParam(myPojoToJsonArraySetHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonArray>> methodWithHandlerAsyncResultMapOfTypeToJsonArrayParam() { 
    io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonArray>> ret = rxMethodWithHandlerAsyncResultMapOfTypeToJsonArrayParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonArray>> rxMethodWithHandlerAsyncResultMapOfTypeToJsonArrayParam() { 
    return AsyncResultSingle.toSingle( myPojoToJsonArrayMapHandler -> {
      delegate.methodWithHandlerAsyncResultMapOfTypeToJsonArrayParam(myPojoToJsonArrayMapHandler);
    });
  }

  public void methodWithTypeToJsonObjectParam(io.vertx.codegen.testmodel.MyPojoToJsonObject myPojoToJsonObject) { 
    delegate.methodWithTypeToJsonObjectParam(myPojoToJsonObject);
  }

  public void methodWithListOfTypeToJsonObjectParam(java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonObject> myPojoToJsonObjectList) { 
    delegate.methodWithListOfTypeToJsonObjectParam(myPojoToJsonObjectList);
  }

  public void methodWithSetOfTypeToJsonObjectParam(java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonObject> myPojoToJsonObjectSet) { 
    delegate.methodWithSetOfTypeToJsonObjectParam(myPojoToJsonObjectSet);
  }

  public void methodWithMapOfTypeToJsonObjectParam(java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonObject> myPojoToJsonObjectMap) { 
    delegate.methodWithMapOfTypeToJsonObjectParam(myPojoToJsonObjectMap);
  }

  public io.vertx.codegen.testmodel.MyPojoToJsonObject methodWithTypeToJsonObjectReturn() { 
    io.vertx.codegen.testmodel.MyPojoToJsonObject ret = delegate.methodWithTypeToJsonObjectReturn();
    return ret;
  }

  public java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonObject> methodWithListOfTypeToJsonObjectReturn() { 
    java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonObject> ret = delegate.methodWithListOfTypeToJsonObjectReturn();
    return ret;
  }

  public java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonObject> methodWithSetOfTypeToJsonObjectReturn() { 
    java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonObject> ret = delegate.methodWithSetOfTypeToJsonObjectReturn();
    return ret;
  }

  public java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonObject> methodWithMapOfTypeToJsonObjectReturn() { 
    java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonObject> ret = delegate.methodWithMapOfTypeToJsonObjectReturn();
    return ret;
  }

  public void methodWithHandlerTypeToJsonObjectParam(io.vertx.core.Handler<io.vertx.codegen.testmodel.MyPojoToJsonObject> myPojoToJsonObjectHandler) { 
    delegate.methodWithHandlerTypeToJsonObjectParam(myPojoToJsonObjectHandler);
  }

  public void methodWithHandlerListOfTypeToJsonObjectParam(io.vertx.core.Handler<java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonObject>> myPojoToJsonObjectListHandler) { 
    delegate.methodWithHandlerListOfTypeToJsonObjectParam(myPojoToJsonObjectListHandler);
  }

  public void methodWithHandlerSetOfTypeToJsonObjectParam(io.vertx.core.Handler<java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonObject>> myPojoToJsonObjectSetHandler) { 
    delegate.methodWithHandlerSetOfTypeToJsonObjectParam(myPojoToJsonObjectSetHandler);
  }

  public void methodWithHandlerMapOfTypeToJsonObjectParam(io.vertx.core.Handler<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonObject>> myPojoToJsonObjectMapHandler) { 
    delegate.methodWithHandlerMapOfTypeToJsonObjectParam(myPojoToJsonObjectMapHandler);
  }

  public io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToJsonObject> methodWithHandlerAsyncResultTypeToJsonObjectParam() { 
    io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToJsonObject> ret = rxMethodWithHandlerAsyncResultTypeToJsonObjectParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<io.vertx.codegen.testmodel.MyPojoToJsonObject> rxMethodWithHandlerAsyncResultTypeToJsonObjectParam() { 
    return AsyncResultSingle.toSingle( myPojoToJsonObjectHandler -> {
      delegate.methodWithHandlerAsyncResultTypeToJsonObjectParam(myPojoToJsonObjectHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonObject>> methodWithHandlerAsyncResultListOfTypeToJsonObjectParam() { 
    io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonObject>> ret = rxMethodWithHandlerAsyncResultListOfTypeToJsonObjectParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.List<io.vertx.codegen.testmodel.MyPojoToJsonObject>> rxMethodWithHandlerAsyncResultListOfTypeToJsonObjectParam() { 
    return AsyncResultSingle.toSingle( myPojoToJsonObjectListHandler -> {
      delegate.methodWithHandlerAsyncResultListOfTypeToJsonObjectParam(myPojoToJsonObjectListHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonObject>> methodWithHandlerAsyncResultSetOfTypeToJsonObjectParam() { 
    io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonObject>> ret = rxMethodWithHandlerAsyncResultSetOfTypeToJsonObjectParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.Set<io.vertx.codegen.testmodel.MyPojoToJsonObject>> rxMethodWithHandlerAsyncResultSetOfTypeToJsonObjectParam() { 
    return AsyncResultSingle.toSingle( myPojoToJsonObjectSetHandler -> {
      delegate.methodWithHandlerAsyncResultSetOfTypeToJsonObjectParam(myPojoToJsonObjectSetHandler);
    });
  }

  public io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonObject>> methodWithHandlerAsyncResultMapOfTypeToJsonObjectParam() { 
    io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonObject>> ret = rxMethodWithHandlerAsyncResultMapOfTypeToJsonObjectParam();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public io.reactivex.rxjava3.core.Single<java.util.Map<java.lang.String,io.vertx.codegen.testmodel.MyPojoToJsonObject>> rxMethodWithHandlerAsyncResultMapOfTypeToJsonObjectParam() { 
    return AsyncResultSingle.toSingle( myPojoToJsonObjectMapHandler -> {
      delegate.methodWithHandlerAsyncResultMapOfTypeToJsonObjectParam(myPojoToJsonObjectMapHandler);
    });
  }

  public static JsonMapperTCK newInstance(io.vertx.codegen.testmodel.JsonMapperTCK arg) {
    return arg != null ? new JsonMapperTCK(arg) : null;
  }

}
