/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava3.codegen.vertx4;

import io.vertx.rxjava3.RxHelper;
import io.vertx.rxjava3.ObservableHelper;
import io.vertx.rxjava3.FlowableHelper;
import io.vertx.rxjava3.impl.AsyncResultMaybe;
import io.vertx.rxjava3.impl.AsyncResultSingle;
import io.vertx.rxjava3.impl.AsyncResultCompletable;
import io.vertx.rxjava3.WriteStreamObserver;
import io.vertx.rxjava3.WriteStreamSubscriber;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.vertx4.TestModel original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.vertx4.TestModel.class)
public class TestModel {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    TestModel that = (TestModel) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<TestModel> __TYPE_ARG = new TypeArg<>(    obj -> new TestModel((io.vertx.codegen.vertx4.TestModel) obj),
    TestModel::getDelegate
  );

  private final io.vertx.codegen.vertx4.TestModel delegate;
  
  public TestModel(io.vertx.codegen.vertx4.TestModel delegate) {
    this.delegate = delegate;
  }

  public TestModel(Object delegate) {
    this.delegate = (io.vertx.codegen.vertx4.TestModel)delegate;
  }

  public io.vertx.codegen.vertx4.TestModel getDelegate() {
    return delegate;
  }

  private static final TypeArg<io.vertx.rxjava3.codegen.vertx4.TestModel> TYPE_ARG_0 = new TypeArg<io.vertx.rxjava3.codegen.vertx4.TestModel>(o1 -> io.vertx.rxjava3.codegen.vertx4.TestModel.newInstance((io.vertx.codegen.vertx4.TestModel)o1), o1 -> o1.getDelegate());

  public static io.reactivex.rxjava3.core.Single<java.lang.Boolean> futureMethod1() { 
    io.reactivex.rxjava3.core.Single<java.lang.Boolean> ret = rxFutureMethod1();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public static io.reactivex.rxjava3.core.Single<java.lang.Boolean> rxFutureMethod1() { 
    return AsyncResultSingle.toSingle(io.vertx.codegen.vertx4.TestModel.futureMethod1(), __value -> __value);
  }

  public static io.reactivex.rxjava3.core.Single<java.lang.Integer> futureMethod2(java.lang.String s) { 
    io.reactivex.rxjava3.core.Single<java.lang.Integer> ret = rxFutureMethod2(s);
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public static io.reactivex.rxjava3.core.Single<java.lang.Integer> rxFutureMethod2(java.lang.String s) { 
    return AsyncResultSingle.toSingle(io.vertx.codegen.vertx4.TestModel.futureMethod2(s), __value -> __value);
  }

  public static io.reactivex.rxjava3.core.Single<io.vertx.rxjava3.codegen.vertx4.TestModel> futureMethod3() { 
    io.reactivex.rxjava3.core.Single<io.vertx.rxjava3.codegen.vertx4.TestModel> ret = rxFutureMethod3();
    ret = ret.cache();
    ret.subscribe(io.vertx.rxjava3.SingleHelper.nullObserver());
    return ret;
  }

  public static io.reactivex.rxjava3.core.Single<io.vertx.rxjava3.codegen.vertx4.TestModel> rxFutureMethod3() { 
    return AsyncResultSingle.toSingle(io.vertx.codegen.vertx4.TestModel.futureMethod3(), __value -> io.vertx.rxjava3.codegen.vertx4.TestModel.newInstance((io.vertx.codegen.vertx4.TestModel)__value));
  }

  public static void function1(java.util.function.Function<io.vertx.rxjava3.core.streams.ReadStream<io.vertx.rxjava3.codegen.vertx4.TestModel>,io.reactivex.rxjava3.core.Flowable<io.vertx.rxjava3.codegen.vertx4.TestModel>> f) { 
    io.vertx.codegen.vertx4.TestModel.function1(new Function<io.vertx.core.streams.ReadStream<io.vertx.codegen.vertx4.TestModel>,io.vertx.core.streams.ReadStream<io.vertx.codegen.vertx4.TestModel>>() {
      public io.vertx.core.streams.ReadStream<io.vertx.codegen.vertx4.TestModel> apply(io.vertx.core.streams.ReadStream<io.vertx.codegen.vertx4.TestModel> arg) {
        io.reactivex.rxjava3.core.Flowable<io.vertx.rxjava3.codegen.vertx4.TestModel> ret = f.apply(io.vertx.rxjava3.core.streams.ReadStream.newInstance((io.vertx.core.streams.ReadStream)arg, new TypeArg<io.vertx.rxjava3.codegen.vertx4.TestModel>(o0 -> io.vertx.rxjava3.codegen.vertx4.TestModel.newInstance((io.vertx.codegen.vertx4.TestModel)o0), o0 -> o0.getDelegate())));
        return io.vertx.rxjava3.impl.ReadStreamSubscriber.asReadStream(ret, obj -> obj.getDelegate()).resume();
      }
    });
  }

  public static TestModel newInstance(io.vertx.codegen.vertx4.TestModel arg) {
    return arg != null ? new TestModel(arg) : null;
  }

}
